// Client.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RPClient.h"
#include "Client.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CTcpFifo (tiny)
void __fastcall MakeTCPD(TCPD *tp, int Type, void *bp, int n)
{
	tp->ID = 0x55;
	tp->Type = BYTE(Type);
	tp->len = BYTE(n);
	if( n && (bp != NULL) ){
		memcpy(tp->Data, bp, n);
	}
}
//---------------------------------------------------------------------------
CTcpFifo::CTcpFifo(void)
{
	memset(Slot, 0, sizeof(Slot));
	Reset();
}
//---------------------------------------------------------------------------
CTcpFifo::~CTcpFifo(void)
{
	Reset();
}
//---------------------------------------------------------------------------
void __fastcall CTcpFifo::Reset(void)
{
	WL = RL = Line = Mode = 0;
	Err = 0;
}
//---------------------------------------------------------------------------
void __fastcall CTcpFifo::WriteByte(BYTE c)
{
	switch(Mode){
		case 0:
			if( c == 0x55 ){
				if( Line >= TCPFIFOMAX ){
					Mode = 0;
				}
				else {
					tp = &Slot[WL];
					tp->ID = 0x55;
					Mode++;
				}
			}
			break;
		case 1:
			tp->Type = c;
			Mode++;
			break;
		case 2:
			Len = c;
			tp->len = BYTE(Len);
			if( Len > 0 ){
				wp = tp->Data;
				Mode++;
			}
			else {                          // f[^Ȃ
				Line++;
				WL++;
				if( WL >= TCPFIFOMAX ) WL = 0;
				Mode = 0;
			}
			break;
		case 3:
			*wp = c;
			wp++;
			Len--;
			if( !Len ){
				*wp = 0;
				Line++;
				WL++;
				if( WL >= TCPFIFOMAX ) WL = 0;
				Mode = 0;
			}
			break;
	}
}
//---------------------------------------------------------------------------
void __fastcall CTcpFifo::WriteString(LPCSTR sp)
{
	for( ; *sp; sp++ ){
		WriteByte(*sp);
	}
}
//---------------------------------------------------------------------------
void __fastcall CTcpFifo::Write(const BYTE *sp, int n)
{
	for( ; n; n--, sp++ ){
		WriteByte(*sp);
	}
}
//---------------------------------------------------------------------------
TCPD* __fastcall CTcpFifo::GetData()
{
	if( !Line ) return NULL;
	TCPD *tp = &Slot[RL];
	RL++;
	if( RL >= TCPFIFOMAX ) RL = 0;
	Line--;
	return tp;
}
/////////////////////////////////////////////////////////////////////////////
// CFifo o֐

IMPLEMENT_DYNAMIC(CClient, CSocket)
/////////////////////////////////////////////////////////////////////////////
// CClient

CClient::CClient(CRPClientApp *pApp)
{
	m_pApp = pApp;
	m_EnabledEvent = TRUE;
}

// ClassWizard KvƂȉ̍sҏWȂłB
#if 0
BEGIN_MESSAGE_MAP(CClient, CSocket)
	//{{AFX_MSG_MAP(CClient)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CClient o֐
//---------------------------------------------------------------------------
void CClient::OnReceive(int nErrorCode) 
{
	ASSERT(m_pApp);
	if( !m_pApp ) return;

	m_pApp->OnReceive(nErrorCode);
	CSocket::OnReceive(nErrorCode);
}

void CClient::OnClose(int nErrorCode) 
{
	CSocket::OnClose(nErrorCode);
	if( m_EnabledEvent ){
		ASSERT(m_pApp);
		if( !m_pApp ) return;
		CWnd *pDialog = m_pApp->GetDialogWindow();
		if( !pDialog ) return;
		pDialog->PostMessage(WM_SOCKETEVENT, MMSO_CLOSE, (DWORD)this);
	}
}
