// Monitor.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RPServer.h"
#include "Monitor.h"
#include "RPServerDlg.h"
#include "CSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSplitter class

CSplitter::CSplitter()
{
	m_pWnd = NULL;
	m_edge = 5;
	m_minsize = 24;
	m_hCursor[0] = GetApp()->LoadStandardCursor(IDC_ARROW);
	m_hCursor[1] = GetApp()->LoadStandardCursor(IDC_SIZENS);
}
BOOL CSplitter::Create(CWnd *pWnd, int splitter, int top, int bottom, int minsize)
{
	m_minsize = minsize;
	m_pWnd = pWnd;
	m_splitter = splitter;
	if( m_splitter < 0 ) m_splitter = (top + bottom) / 2;
	SetRange(top, bottom);
	return TRUE;
}
void CSplitter::SetRange(int top, int bottom)
{
	m_top = top + m_minsize;
	m_bottom = bottom - m_minsize;
	if( m_splitter < m_top ) m_splitter = m_top;
	if( m_splitter > m_bottom ) m_splitter = m_bottom;
}
BOOL CSplitter::HitTest(CPoint &point)
{
	return ( (point.y > (m_splitter - m_edge)) && (point.y < (m_splitter + m_edge)) );
}
int CSplitter::OnMouseMove(CPoint &point)
{
	int r = FALSE;
	if( !m_pWnd ) return r;
	int index = 0;
	if( m_pWnd->GetCapture() == m_pWnd ){
		index = 1;
		if( (point.y > m_top) && (point.y < m_bottom) ){
			m_splitter = point.y;
			r = TRUE;
		}
	}
	else if( HitTest(point) ){
		index = 1;
	}
	::SetCursor(m_hCursor[index]);
	return r;
}
void CSplitter::OnLButtonDown(CPoint &point)
{
	if( !m_pWnd ) return;
	if( HitTest(point) ){
		m_pWnd->SetCapture();
		::SetCursor(m_hCursor[1]);
	}
}
void CSplitter::OnLButtonUp(CPoint &point) 
{
	if( !m_pWnd ) return;
	if( m_pWnd->GetCapture() == m_pWnd ){
		ReleaseCapture();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMonitor _CAO


CMonitor::CMonitor(CWnd* pParent /*=NULL*/)
	: CDialog(CMonitor::IDD, pParent)
{
	m_Init = FALSE;
	m_XTX = m_XRX = 0;
	//{{AFX_DATA_INIT(CMonitor)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CMonitor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonitor)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_VIEWTX, m_sDlgViewTX);
	DDX_Control(pDX, IDC_VIEWRX, m_sDlgViewRX);
}


BEGIN_MESSAGE_MAP(CMonitor, CDialog)
	//{{AFX_MSG_MAP(CMonitor)
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_CLOSE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonitor bZ[W nh

//---------------------------------------------------------------------------
BOOL CMonitor::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	MONISTORAGE *pMoniStorage = GetMoniStorage();
	MoveWindow(&pMoniStorage->m_rc);
	GetClientRect(&m_rcClient);
	m_Splitter.Create(this, pMoniStorage->m_splitter, 0, m_rcClient.bottom, 24);
	m_Init = TRUE;
	UpdateItemAlign();
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL CMonitor::DestroyWindow() 
{
	MONISTORAGE *pMoniStorage = GetMoniStorage();
	GetWindowRect(&pMoniStorage->m_rc);
	pMoniStorage->m_splitter = m_Splitter.GetSplitter();
	return CDialog::DestroyWindow();
}
//---------------------------------------------------------------------------
void CMonitor::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if( !m_Init ) return;

	m_rcClient.right = cx; m_rcClient.bottom = cy;
	m_Splitter.SetRange(0, cy);
	UpdateItemAlign();
	m_XTX = m_XRX = 0;
}
//---------------------------------------------------------------------------
void CMonitor::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_Splitter.OnMouseMove(point) ) UpdateItemAlign();
	CDialog::OnMouseMove(nFlags, point);
}
//---------------------------------------------------------------------------
void CMonitor::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_Splitter.OnLButtonDown(point);
	CDialog::OnLButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void CMonitor::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_Splitter.OnLButtonUp(point);
	CDialog::OnLButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
void CMonitor::OnCancel() 
{
	CDialog::OnCancel();

	// ̃IuWFNg̍폜̂߂ɃCEChEɃbZ[W𑗂܂
	GetApp()->m_pMainWnd->PostMessage(WM_SOCKETEVENT, MMSO_MONICLOSE, (DWORD)this);
}
//---------------------------------------------------------------------------
void CMonitor::UpdateItemAlign(void)
{
	UpdateItemAlign(m_rcClient.right, m_rcClient.bottom, m_Splitter.GetSplitter());
}
//---------------------------------------------------------------------------
void CMonitor::UpdateItemAlign(int cx, int cy, int splitter)
{
	if( !m_Init ) return;
	RECT rc;
	rc.left = 0; rc.top = 0;
	rc.bottom = splitter - 1; rc.right = cx;
	m_sDlgViewTX.MoveWindow(&rc, TRUE);
	rc.top = rc.bottom + 1;
	rc.bottom = cy;
	m_sDlgViewRX.MoveWindow(&rc, TRUE);
}
//---------------------------------------------------------------------------
void CMonitor::Dump(CDumpStatic *pStatic, int &x, BYTE c)
{
	char bf[32];
	pStatic->PutChar(x ? ' ' : '\n', 0);
	wsprintf(bf, "%02X", c);
	pStatic->PutText(bf, 0);
	x++;
	if( x >= (pStatic->GetColWidth() / 3) ) x = 0;
}
//---------------------------------------------------------------------------
void CMonitor::Clear(void)
{
	m_sDlgViewTX.Clear();
	m_sDlgViewRX.Clear();
}
//---------------------------------------------------------------------------
void CMonitor::Add(LPCSTR pText, BOOL tx)
{
	CDumpStatic *pStatic;
	if( tx ){
		m_XTX = 0;
		pStatic = &m_sDlgViewTX;
	}
	else {
		m_XRX = 0;
		pStatic = &m_sDlgViewRX;
	}
	pStatic->PutText("\n", TRUE);
	pStatic->PutText(pText, TRUE);
}
//---------------------------------------------------------------------------
void CMonitor::Dump(BYTE c, BOOL tx)
{
	if( tx ){
		Dump(&m_sDlgViewTX, m_XTX, c);
	}
	else {
		Dump(&m_sDlgViewRX, m_XRX, c);
	}
}
