// RPClient.cpp : DLL p̏̒`s܂B
//

#include "stdafx.h"
#include "RPClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRPClientApp

BEGIN_MESSAGE_MAP(CRPClientApp, CWinApp)
	//{{AFX_MSG_MAP(CRPClientApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRPClientApp ̍\z

CRPClientApp::CRPClientApp()
{
	m_pSocket = NULL;
	m_pDialog = NULL;
	m_TcpRetryTime = 0;
	m_ServerName = "";
	m_PortTCP = 10202;

	m_hWnd = NULL;
	m_uMsg = 0;
	m_Busy = 0;
	m_ptt = 0;
	m_Freq = 0;
    m_DefCmd = -1;
}

/////////////////////////////////////////////////////////////////////////////
// B CRPClientApp IuWFNg

CRPClientApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CRPClientApp ̏
BOOL CRPClientApp::InitInstance()
{
	if(!AfxSocketInit()){
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	m_clBack = GetSysColor(COLOR_BTNFACE);
	SetDialogBkColor(m_clBack);

	m_pDialog = new CRPDialog(NULL, this);
	ASSERT(m_pDialog);
	if( !m_pDialog ) return FALSE;

	char IniName[MAX_PATH];
	::GetModuleFileName(m_hInstance, IniName, sizeof(IniName));
	SetEXT(IniName, "ini");
	if( m_pszProfileName ) free(LPVOID(m_pszProfileName));
	m_pszProfileName = _tcsdup(IniName);

	m_PortTCP = GetProfileInt("N.TCP", "Port", m_PortTCP);
	m_ServerName = GetProfileString("N.TCP", "Server", m_ServerName);
	m_pDialog->m_ServerName = m_ServerName;
	m_pDialog->m_AutoConnect = GetProfileInt("N.TCP", "AutoConnect", FALSE);

	m_pDialog->Create(IDD_DIALOG, m_pDialog->GetDesktopWindow());

	RECT rc;
	rc.left = GetProfileInt("N.Window", "Left", 100);
	rc.top = GetProfileInt("N.Window", "Top", 50);
	int iconic = GetProfileInt("N.Window", "Minimized", FALSE);
	m_pDialog->WindowControl(&rc, iconic ? SW_MINIMIZE : SW_SHOW);

	DispStatus();
	return TRUE;
}
//---------------------------------------------------------------------------
int CRPClientApp::ExitInstance() 
{
	if( m_pDialog ){
		WriteProfileInt("N.TCP", "Port", m_PortTCP);
		WriteProfileString("N.TCP", "Server", m_ServerName);
		WriteProfileInt("N.TCP", "AutoConnect", m_pDialog->m_AutoConnect);
		BOOL iconic = m_pDialog->IsIconic();
		WriteProfileInt("N.Window", "Minimized", iconic);
		if( !iconic ){
			RECT rc;
			m_pDialog->GetWindowRect(&rc);
			WriteProfileInt("N.Window", "Left", rc.left);
			WriteProfileInt("N.Window", "Top", rc.top);
		}
		m_pDialog->DestroyWindow();
		delete m_pDialog;
		m_pDialog = NULL;
	}
	DeleteSocket();
	return CWinApp::ExitInstance();
}
//---------------------------------------------------------------------------
void CRPClientApp::SetEXT(LPSTR s, LPCSTR pKey)
{
	int len = strlen(s);
	if( !len ) return;
	LPSTR t = s + len - 1;
	for( ; t > s; t-- ){
		if( *t == '.' ){
			t++;
			strcpy(t, pKey);
			return;
		}
	}
	t = s + len - 1;
	*t++ = '.';
	strcpy(t, pKey);
}
//---------------------------------------------------------------------------
BOOL CRPClientApp::CreateSocket(LPCSTR pName, UINT port)
{
	DeleteSocket();

	m_RxD.Clear();
	m_pSocket = new CClient(this);
	ASSERT(m_pSocket);
	if( !m_pSocket ) return FALSE;

	if( !m_pSocket->Create() || !m_pSocket->Connect(pName, port) ){
		delete m_pSocket;
		m_pSocket = NULL;
	}
	return m_pSocket != NULL;
}
//---------------------------------------------------------------------------
void CRPClientApp::DeleteSocket(void)
{
	m_RxD.Clear();
	if( m_pSocket ){
		m_pSocket->EnableEvent(FALSE);
		delete m_pSocket;
		m_pSocket = NULL;
	}
	m_TcpRetryTime = 30000/WTIMERINTERVAL;
}
//---------------------------------------------------------------------------
BOOL CRPClientApp::SendBuf(LPVOID p, int n)
{
	if( !IsConnected() ) return FALSE;

	DWORD dwTimeOut = ::GetTickCount() + STIMEOUT;
	int len;
	do {
		len = m_pSocket->Send(p, n);
		if( len == n ){
			return TRUE;
		}
		else if( len == SOCKET_ERROR ){
			break;
		}
		else if( len < n ){
			n -= len;
			p = LPBYTE(p)+len;
		}
		::Sleep(10);
		if( !IsConnected() ) break;
	} while( dwTimeOut > ::GetTickCount() );
	DeleteSocket();
	m_TcpRetryTime = 0;
	DispStatus();
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL CRPClientApp::SendServer(TCPD *tp)
{
	return SendBuf(tp, (sizeof(TCPD)-sizeof(tp->Data)) + tp->len );
}
//---------------------------------------------------------------------------
BOOL CRPClientApp::SendServer(int cmd, LPVOID p, UINT len)
{
	if( !IsConnected() ) return FALSE;

	TCPD td;
    MakeTCPD(&td, cmd, p, len);
    return SendServer(&td);
}
//---------------------------------------------------------------------------
void CRPClientApp::OnTimer(void)
{
	if( !IsConnected() && m_pDialog->IsAutoConnect() ){
		m_pDialog->GetServerName(m_ServerName);
		if( !m_ServerName.IsEmpty() ){
			if( m_TcpRetryTime ){
				m_TcpRetryTime--;
				DispStatus();
			}
			else {
				ReqConnect();
			}
		}
	}
}
//---------------------------------------------------------------------------
void CRPClientApp::ReqConnect(void)
{
	m_pDialog->GetServerName(m_ServerName);
	if( !m_ServerName.IsEmpty() ){
		m_TcpRetryTime = -1;
		DispStatus();
		m_TcpFifo.Reset();
		CreateSocket(m_ServerName, m_PortTCP);
		m_TcpRetryTime = 30000/WTIMERINTERVAL;
		DispStatus();
		if( IsConnected() ) m_Busy = FALSE;
	}
}
//---------------------------------------------------------------------------
void CRPClientApp::ReqDisconnect(void)
{
	if( IsConnected() ){
		DeleteSocket();
	}
	m_pDialog->GetServerName(m_ServerName);
	DispStatus();
}
//---------------------------------------------------------------------------
void CRPClientApp::DispStatus(void)
{
	char bf[256];

	COLORREF col = RGB(0, 255, 0);
	BOOL fBConnect = !m_ServerName.IsEmpty();
	if( IsConnected() ){
		CString address;
		UINT	port;
		m_pSocket->GetSockName(address, port);
		wsprintf(bf, "TCP : Connected to %s", address);
		fBConnect = FALSE;
	}
	else {
		if( m_pDialog->IsAutoConnect() && !m_ServerName.IsEmpty() ){
			if( m_TcpRetryTime > 0 ){
				wsprintf(bf, "### Discconected  (%u)", m_TcpRetryTime * WTIMERINTERVAL / 1000);
			}
			else {
				strcpy(bf, "TCP : Trying...");
				fBConnect = FALSE;
			}
			col = RGB(255, 255, 0);
		}
		else {
			strcpy(bf, "### Disconnected");
			col = RGB(255, 0, 0);
		}
	}
	m_pDialog->UpdateButton(fBConnect);
	m_pDialog->UpdateStatus(bf, col);
}
//---------------------------------------------------------------------------
LRESULT CRPClientApp::OnSocketEvent(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case MMSO_STATUS:
			DispStatus();
			break;
		case MMSO_CLOSE:
			ASSERT(((CClient *)lParam) == m_pSocket);
			DeleteSocket();
			m_TcpRetryTime = 0;
			DispStatus();
			break;
    }
	return TRUE;
}
//---------------------------------------------------------------------------
void CRPClientApp::OnReceive(int nErrorCode) 
{
	if( !IsConnected() ) return;
	if( nErrorCode == SOCKET_ERROR ) return;
	
	BYTE    bf[8192];
	UINT    n;
	TCPD	*tp;

	n = m_pSocket->Receive(bf, sizeof(bf));
	if( n != SOCKET_ERROR ){
		m_TcpFifo.Write(bf, n);
		while( (tp = m_TcpFifo.GetData())!=NULL ){
			switch(tp->Type){
				case retInit:
                	if( m_hWnd && m_uMsg ){
						::PostMessage(m_hWnd, m_uMsg, MMR_DEFCOMMAND, 0);
                    }
                    else {
						m_DefCmd = 0;
                    }
					break;
				case retBusy:
					m_Busy = int(*(BYTE *)tp->Data);
					break;
				case retChar:
					m_RxD.PutData(*(BYTE *)tp->Data);
					break;
				case retFreq:
                	if( m_hWnd && m_uMsg ){
						::PostMessage(m_hWnd, m_uMsg, MMR_VFO, DWORD(*(DWORD *)tp->Data));
                    }
                    else {
						m_Freq = DWORD(*(DWORD *)tp->Data);
                    }
					break;
			}
		}
	}
}
//---------------------------------------------------------------------------
void CRPClientApp::mmSetHandle(HWND hWnd, UINT uMsg)
{
	m_hWnd = hWnd;
	m_uMsg = uMsg;
}
//---------------------------------------------------------------------------
DWORD CRPClientApp::mmGetStatus(void)
{
	DWORD Status = 0;

	if( m_RxD.GetCount() ) Status |= mmrpstatusRX;
	if( m_Busy ) Status |= mmrpstatusTXBUSY;
	if( m_Freq ) Status |= mmrpstatusFREQ;
    if( m_DefCmd != -1 ) Status |= mmrpstatusDEFCMD;
	return Status;
}
//---------------------------------------------------------------------------
void CRPClientApp::mmSetPTT(LONG tx)
{
	m_ptt = tx;
	if( !IsConnected() ) return;
	TCPD td;
	MakeTCPD(&td, cmdPTT, &tx, sizeof(tx));
	SendServer(&td);
}
//---------------------------------------------------------------------------
void CRPClientApp::mmPutChar(BYTE c)
{
	if( !IsConnected() ) return;
	if( m_Busy ) return;

	TCPD td;
	MakeTCPD(&td, cmdPutChar, &c, sizeof(c));
	SendServer(&td);
}
//---------------------------------------------------------------------------
BYTE CRPClientApp::mmGetChar(void)
{
	return m_RxD.GetCount() ? m_RxD.GetData() : 0;
}
//---------------------------------------------------------------------------
void CRPClientApp::mmPolling(void)
{
	if( !IsConnected() ) return;

	TCPD td;
	MakeTCPD(&td, cmdPolling, NULL, 0);
	SendServer(&td);
}
//---------------------------------------------------------------------------
LONG CRPClientApp::mmGetFreq(void)
{
	DWORD fq = m_Freq;
	m_Freq = 0;
	return fq;
}
//---------------------------------------------------------------------------
LONG CRPClientApp::mmGetDefCommand(void)
{
	DWORD cmd = m_DefCmd;
    m_DefCmd = -1;
    return cmd;
}
/////////////////////////////////////////////////////////////////////////////
// EXPORT functions
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmrpOpen(HWND hWnd, UINT uMsg)
{
	// DLLA^b`ꂽケ̃t@NVĂяo܂B
	// DLLł͊ɃIuWFNgĂ̂ŁAŐKv͂܂B
	theApp.mmSetHandle(hWnd, uMsg);
	return TRUE;
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmrpClose(void)
{
	// DLLf^b`钼Oɂ̃t@NVĂяo܂B
	// DLLł͌ŌĂ΂ExitInstance()Ō㏈s܂B
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmrpSetHandle(HWND hWnd, UINT uMsg)
{
	theApp.mmSetHandle(hWnd, uMsg);
}
//---------------------------------------------------------------------------
extern "C" DWORD __declspec(dllexport) __stdcall
mmrpGetStatus(void)
{
	return theApp.mmGetStatus();
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmrpSetPTT(LONG tx)
{
	theApp.mmSetPTT(tx);
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmrpPutChar(BYTE c)
{
	theApp.mmPutChar(c);
}
//---------------------------------------------------------------------------
extern "C" BYTE __declspec(dllexport) __stdcall
mmrpGetChar(void)
{
	return theApp.mmGetChar();
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmrpPolling(void)
{
	theApp.mmPolling();
}
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmrpGetFreq(void)
{
	return theApp.mmGetFreq();
}
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmrpGetDefCommand(void)
{
	return theApp.mmGetDefCommand();
}
