// RPServerDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RPServer.h"
#include "RPServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
const int _tBAUD[]={1200, 2400, 4800, 9600, 14400, 19200, 38400, 0x80000000};
const LPCSTR _tPORT[]={
	"COM1", "COM2", "COM3", "COM4", "COM5", "COM6", "COM7", "COM8", NULL
};

int IndexOf(const int *pTbl, int d)
{
	for( int i = 0; *pTbl != 0x80000000; i++, pTbl++ ){
		if( *pTbl == d ) return i;
	}
	return 0;
}
int IndexOf(const LPCSTR *pTbl, LPCSTR pKey)
{
	for( int i = 0; *pTbl != NULL; i++, pTbl++ ){
		if( !strcmpi(*pTbl, pKey) ) return i;
	}
	return 0;
}
void AddComboItem(CComboBox *pBox, const int *pTbl)
{
	char bf[32];
	while(*pTbl!=0x80000000){
		wsprintf(bf, "%d", *pTbl++);
		pBox->AddString(bf);
	}
}
void AddComboItem(CComboBox *pBox, const LPCSTR *pTbl)
{
	while(*pTbl){
		pBox->AddString(*pTbl++);
	}
}
/////////////////////////////////////////////////////////////////////////////
// CRPServerDlg _CAO

CRPServerDlg::CRPServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRPServerDlg::IDD, pParent)
{
	m_pSocket = NULL;
	m_pComm = NULL;
	m_pMonitor = NULL;
	m_PortTCP = 10202;
	m_Connection.RemoveAll();
	m_Freq = 140800;
	m_MoniStorage.m_rc.left = 100; m_MoniStorage.m_rc.top = 50;
	m_MoniStorage.m_rc.right = 350; m_MoniStorage.m_rc.bottom = 340;
	m_MoniStorage.m_splitter = -1;
	//{{AFX_DATA_INIT(CRPServerDlg)
	m_DlgPort = -1;
	m_DlgBaud = -1;
	m_DlgLength = -1;
	m_DlgStop = -1;
	m_DlgParity = -1;
	m_DlgDTR = FALSE;
	m_DlgRTS = FALSE;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRPServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRPServerDlg)
	DDX_Control(pDX, IDC_MONITOR, m_DlgMonitor);
	DDX_Control(pDX, IDC_MINIMIZE, m_DlgMinimized);
	DDX_CBIndex(pDX, IDC_PORT, m_DlgPort);
	DDX_CBIndex(pDX, IDC_BAUD, m_DlgBaud);
	DDX_CBIndex(pDX, IDC_LENGTH, m_DlgLength);
	DDX_CBIndex(pDX, IDC_STOP, m_DlgStop);
	DDX_CBIndex(pDX, IDC_PARITY, m_DlgParity);
	DDX_Check(pDX, IDC_DTR, m_DlgDTR);
	DDX_Check(pDX, IDC_RTS, m_DlgRTS);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_NSTATUS, m_csDlgNStatus);
	DDX_Control(pDX, IDC_SPORT, m_csDlgPort);
}

BEGIN_MESSAGE_MAP(CRPServerDlg, CDialog)
	//{{AFX_MSG_MAP(CRPServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_CBN_SELCHANGE(IDC_BAUD, OnSelchangeBaud)
	ON_CBN_SELCHANGE(IDC_LENGTH, OnSelchangeLength)
	ON_CBN_SELCHANGE(IDC_STOP, OnSelchangeStop)
	ON_CBN_SELCHANGE(IDC_PARITY, OnSelchangeParity)
	ON_BN_CLICKED(IDC_DTR, OnDtr)
	ON_BN_CLICKED(IDC_RTS, OnRts)
	ON_BN_CLICKED(IDC_MINIMIZE, OnMinimize)
	ON_BN_CLICKED(IDC_MONITOR, OnMonitor)
	//}}AFX_MSG_MAP
    ON_MESSAGE(WM_COMMEVENT, OnCommEvent)
    ON_MESSAGE(WM_SOCKETEVENT, OnSocketEvent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRPServerDlg bZ[W nh

BOOL CRPServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	AddComboItem((CComboBox *)GetDlgItem(IDC_PORT), _tPORT);
	AddComboItem((CComboBox *)GetDlgItem(IDC_BAUD), _tBAUD);
	CRPServerApp *pApp = GetApp();
	ASSERT(pApp);
	pApp->RegisterMainWindow(m_hWnd);

	m_PortTCP = pApp->GetProfileInt("TCP", "Port", m_PortTCP);

	m_pSocket = new CLSocket(this);
	ASSERT(m_pSocket);
	if( !m_pSocket->Create(m_PortTCP) || !m_pSocket->Listen() ){
		delete m_pSocket;
		m_pSocket = NULL;
	}

	RECT rc;
	rc.left = pApp->GetProfileInt("Window", "Left", 100);
	rc.top = pApp->GetProfileInt("Window", "Top", 50);
	int iconic = pApp->GetProfileInt("Window", "Minimized", FALSE);
	m_DlgMinimized.SetCheck(iconic);
	if( rc.left < -200 ) rc.left = 0;
	if( rc.top < -100 ) rc.top = 0;
	::SetWindowPos(m_hWnd, HWND_TOPMOST, rc.left, rc.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
	ShowWindow(iconic ? SW_MINIMIZE : SW_SHOW);
	m_DlgMonitor.SetCheck(pApp->GetProfileInt("Window", "Monitor", FALSE));

	m_MoniStorage.m_rc.left = pApp->GetProfileInt("M.Window", "Left", m_MoniStorage.m_rc.left);
	m_MoniStorage.m_rc.top = pApp->GetProfileInt("M.Window", "Top", m_MoniStorage.m_rc.top);
	m_MoniStorage.m_rc.right = pApp->GetProfileInt("M.Window", "Width", m_MoniStorage.m_rc.right);
	m_MoniStorage.m_rc.bottom = pApp->GetProfileInt("M.Window", "Height", m_MoniStorage.m_rc.bottom);
	m_MoniStorage.m_splitter = pApp->GetProfileInt("M.Window", "Splitter", m_MoniStorage.m_splitter);

	m_CommPara.LoadProfile(pApp);
	UpdatePort(FALSE);
	DispStatus();
	OpenPort();
	if( m_DlgMonitor.GetCheck() ) OpenMonitor();
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

BOOL CRPServerDlg::DestroyWindow() 
{
	if( m_pSocket ){
		delete m_pSocket;
		m_pSocket = NULL;
	}
	POSITION pos;
	for( pos = m_Connection.GetHeadPosition(); pos != NULL; ){
		CCSocket *pSocket = (CCSocket*)m_Connection.GetNext(pos);
		pSocket->EnableEvent(FALSE);
		pSocket->Close();
		delete pSocket;
	}
	m_Connection.RemoveAll();
	ClosePort();
	UpdatePort(TRUE);

	CRPServerApp *pApp = GetApp();
	ASSERT(pApp);
	pApp->WriteProfileInt("TCP", "Port", m_PortTCP);
	m_CommPara.SaveProfile(pApp);

	int iconic = IsIconic();
	if( !iconic ){
		RECT rc;
		GetWindowRect(&rc);
		pApp->WriteProfileInt("Window", "Left", rc.left);
		pApp->WriteProfileInt("Window", "Top", rc.top);
	}
	pApp->WriteProfileInt("Window", "Minimized", m_DlgMinimized.GetCheck());
	pApp->WriteProfileInt("Window", "Monitor", m_DlgMonitor.GetCheck() && !m_DlgMinimized.GetCheck());

	CloseMonitor();
	pApp->WriteProfileInt("M.Window", "Left", m_MoniStorage.m_rc.left);
	pApp->WriteProfileInt("M.Window", "Top", m_MoniStorage.m_rc.top);
	pApp->WriteProfileInt("M.Window", "Width", m_MoniStorage.m_rc.right);
	pApp->WriteProfileInt("M.Window", "Height", m_MoniStorage.m_rc.bottom);
	pApp->WriteProfileInt("M.Window", "Splitter", m_MoniStorage.m_splitter);

	return CDialog::DestroyWindow();
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CRPServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CRPServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//---------------------------------------------------------------------------
LRESULT CRPServerDlg::OnSocketEvent(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case MMSO_STATUS:
			DispStatus();
			break;
		case MMSO_CLOSE:
			ASSERT(lParam);
			CloseSocket((CCSocket*)lParam);
			break;
		case MMSO_CONNECT:
			DispStatus();
			SendCommandRequest(0);
			break;
		case MMSO_MONICLOSE:
			ASSERT(lParam);
			CloseMonitor();
			break;
    }
	return TRUE;
}
//---------------------------------------------------------------------------
void CRPServerDlg::OnAccept(int nErrorCode)
{
	ASSERT(m_pSocket);
	if( !m_pSocket ) return;

	CCSocket* pSocket = new CCSocket(this);

	if(m_pSocket->Accept(*pSocket)){
		m_Connection.AddTail(pSocket);
		PostMessage(WM_SOCKETEVENT, MMSO_CONNECT, 0);
	}
	else {
		delete pSocket;
	}
}
//---------------------------------------------------------------------------
void CRPServerDlg::OnReceive(CCSocket *pSocket, int nErrorCode)
{
	if( nErrorCode == SOCKET_ERROR ) return;
	ASSERT(pSocket);
	BYTE    bf[8192];
	UINT    n;
	TCPD	*tp;

	try{
		n = pSocket->Receive(bf, sizeof(bf));
	}
	catch(...){
		n = SOCKET_ERROR;
	}
	if( n != SOCKET_ERROR ){
		m_TcpFifo.Write(bf, n);
		while( (tp = m_TcpFifo.GetData())!=NULL ){
			switch(tp->Type){
				case cmdPutChar:
					PutChar(*((BYTE *)tp->Data));
					break;
				case cmdPTT:
					SetPTT(*((LONG *)tp->Data));
					break;
				case cmdPolling:
#if DEBUG_VFO
					SendVFO(m_Freq);
					m_Freq += 10;
#endif
					if( m_pMonitor ) m_pMonitor->Add("Polling", TRUE);
					break;
			}
		}
	}
}
//---------------------------------------------------------------------------
void CRPServerDlg::DispStatus(void)
{
	char bf[128];
	POSITION pos;

	COLORREF col;
	if( !m_pSocket ){
		wsprintf(bf, "CSocket class creation failed (Port=%u)", m_PortTCP);
		col = RGB(255,0,0);
	}
	else if( m_Connection.GetCount() && ((pos = m_Connection.GetHeadPosition()) !=NULL) ){
		CCSocket *pSocket = (CCSocket *)m_Connection.GetAt(pos);
		CString address;
		UINT	port;
		pSocket->GetSockName(address, port);
		wsprintf(bf, "TCP : Connected to %s", address);
		col = RGB(0,255,0);
	}
	else {
		char host[256];
		gethostname(host, sizeof(host));
		wsprintf(bf, "TCP : Listening(%s)...  (Port=%u)", host, m_PortTCP);
		col = RGB(255,255,0);
	}
	m_csDlgNStatus.SetWindowText(bf, col);
}
//---------------------------------------------------------------------------
void CRPServerDlg::DispCommStatus(void)
{
	m_csDlgPort.SetWindowText("Port", IsCommOpen() ? RGB(0,255,0) : RGB(255,0,0));
}
//---------------------------------------------------------------------------
void CRPServerDlg::CloseSocket(CCSocket *pSocket)
{
	ASSERT(pSocket);
	pSocket->EnableEvent(FALSE);
	pSocket->Close();

	POSITION pos, cur;
	for( pos = m_Connection.GetHeadPosition(); pos != NULL; ){
		cur = pos;
		CCSocket *p = (CCSocket*)m_Connection.GetNext(pos);
		if( p == pSocket ){
			m_Connection.RemoveAt(cur);
			break;
		}
	}
	delete pSocket;
	DispStatus();
}
//---------------------------------------------------------------------------
BOOL CRPServerDlg::SendBuf(CCSocket *pSocket, LPVOID p, int n)
{
	DWORD dwTimeOut = ::GetTickCount() + STIMEOUT;
	int len;
	do {
		try {
			len = pSocket->Send(p, n);
		}
		catch(...){
			break;
		}
		if( len == n ){
			return TRUE;
		}
		else if( len == SOCKET_ERROR ){
			break;
		}
		else if( len < n ){
			n -= len;
			p = LPBYTE(p)+len;
		}
		::Sleep(10);
	} while( dwTimeOut > ::GetTickCount() );
	CloseSocket(pSocket);
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL CRPServerDlg::SendClient(TCPD *tp)
{
	POSITION pos;
	for( pos = m_Connection.GetHeadPosition(); pos != NULL; ){
		CCSocket *pSocket = (CCSocket*)m_Connection.GetNext(pos);
		if( !SendBuf(pSocket, tp, (sizeof(TCPD)-sizeof(tp->Data)) + tp->len) ) return FALSE;
	}
    return TRUE;
}
//---------------------------------------------------------------------------
BOOL CRPServerDlg::SendClient(int cmd, LPVOID p, int len)
{
	TCPD td;
    MakeTCPD(&td, cmd, p, len);
    return SendClient(&td);
}
//---------------------------------------------------------------------------
BOOL CRPServerDlg::SendCommandRequest(int cmd)
{
	BYTE	b = BYTE(cmd);
	int r = SendClient(retInit, &b, sizeof(b));
	if( m_pMonitor ) m_pMonitor->Add("DefCommand", FALSE);
	return r;
}
//---------------------------------------------------------------------------
void CRPServerDlg::SendBusy(int busy)
{
	BYTE	b = BYTE(busy);
	SendClient(retBusy, &b, sizeof(b));
	if( m_pMonitor ) m_pMonitor->Add("Busy/Ready", FALSE);
}
//---------------------------------------------------------------------------
void CRPServerDlg::SendChar(BYTE c)
{
	BYTE	b = BYTE(c);
	SendClient(retChar, &b, sizeof(b));
}
//---------------------------------------------------------------------------
void CRPServerDlg::SendVFO(LONG fq)
{
	DWORD	d = DWORD(fq);
	SendClient(retFreq, &d, sizeof(d));
	if( m_pMonitor ) m_pMonitor->Add("VFO", FALSE);
}
//---------------------------------------------------------------------------
void CRPServerDlg::UpdatePort(BOOL bSaveAndValidate)
{
	if( bSaveAndValidate ){
		UpdateData(TRUE);
		m_CommPara.m_Name = _tPORT[m_DlgPort];
		m_CommPara.m_Baud = _tBAUD[m_DlgBaud];
		m_CommPara.m_Length = m_DlgLength;
		m_CommPara.m_Stop = m_DlgStop;
		m_CommPara.m_Parity = m_DlgParity;
		m_CommPara.m_PTT = DWORD(m_DlgDTR) | (DWORD(m_DlgRTS) << 1);
	}
	else {
		m_DlgPort = IndexOf(_tPORT, m_CommPara.m_Name);
		m_DlgBaud = IndexOf(_tBAUD, m_CommPara.m_Baud);
		m_DlgLength = m_CommPara.m_Length;
		m_DlgStop = m_CommPara.m_Stop;
		m_DlgParity = m_CommPara.m_Parity;
		m_DlgDTR = m_CommPara.m_PTT & 1;
		m_DlgRTS = m_CommPara.m_PTT & 2;
		UpdateData(FALSE);
	}
}
//---------------------------------------------------------------------------
void CRPServerDlg::OnPortChange(void)
{
	UpdatePort(TRUE);
	OpenPort();
}
//---------------------------------------------------------------------------
void CRPServerDlg::OpenPort(void)
{
	CWaitCursor w;

	ClosePort();
	m_pComm = new CComm();
	if( !m_pComm->Open(m_hWnd, &m_CommPara) ){
		delete m_pComm;
		m_pComm = NULL;
	}
	else {
		SendCommandRequest(0);
	}
	DispCommStatus();
}
//---------------------------------------------------------------------------
void CRPServerDlg::ClosePort(void)
{
	if( IsCommOpen() ){
		CWaitCursor w;
		delete m_pComm;
		m_pComm = NULL;
	}
}
//---------------------------------------------------------------------------
void CRPServerDlg::SetPTT(int sw)
{
	if( IsCommOpen() ){
		m_pComm->SetPTT(sw);
	}
	if( !m_pMonitor ) return;
	m_pMonitor->Add(sw ? "PTT ON" : "PTT OFF", TRUE);
}

//---------------------------------------------------------------------------
void CRPServerDlg::PutChar(BYTE c)
{
	if( IsCommOpen() ) m_pComm->PutChar(c);

	if( !m_pMonitor ) return;
	m_pMonitor->Dump(c, TRUE);
}
//---------------------------------------------------------------------------
LRESULT CRPServerDlg::OnCommEvent(WPARAM wParam, LPARAM lParam)
{
	if( !IsCommOpen() ) return FALSE;

	if( !wParam ){
		while(m_pComm->GetRxLen()){
			BYTE c = m_pComm->GetChar();
			SendChar(c);
			if( m_pMonitor ) m_pMonitor->Dump(c, FALSE);
		}
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void CRPServerDlg::OnSelchangePort() 
{
	OnPortChange();
}
void CRPServerDlg::OnSelchangeBaud() 
{
	OnPortChange();
}
void CRPServerDlg::OnSelchangeLength() 
{
	OnPortChange();
}
void CRPServerDlg::OnSelchangeStop() 
{
	OnPortChange();
}
void CRPServerDlg::OnSelchangeParity() 
{
	OnPortChange();
}
void CRPServerDlg::OnDtr() 
{
	OnPortChange();
}
void CRPServerDlg::OnRts() 
{
	OnPortChange();
}
void CRPServerDlg::OnMinimize() 
{
	if( m_DlgMinimized.GetCheck() ){
		ShowWindow(SW_MINIMIZE);
	}
}
void CRPServerDlg::OnMonitor() 
{
	if( m_DlgMonitor.GetCheck() ){
		OpenMonitor();
	}
	else {
		CloseMonitor();
	}
}
//---------------------------------------------------------------------------
void CRPServerDlg::OpenMonitor(void)
{
	if( !m_pMonitor ){
		m_pMonitor = new CMonitor(this);
		m_pMonitor->Create(IDD_MONITOR, this);
	}
	m_DlgMonitor.SetCheck(TRUE);
}
//---------------------------------------------------------------------------
void CRPServerDlg::CloseMonitor(void)
{
	if( m_pMonitor ){
		m_pMonitor->DestroyWindow();
		delete m_pMonitor;
		m_pMonitor = NULL;
		m_DlgMonitor.SetCheck(FALSE);
	}
}
