// RPServerDlg.h : wb_[ t@C
//

#if !defined(AFX_RPSERVERDLG_H__842C61C4_80A2_412E_B5D8_286FEC3FF2DE__INCLUDED_)
#define AFX_RPSERVERDLG_H__842C61C4_80A2_412E_B5D8_286FEC3FF2DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ColorStatic.h"
#include "CSocket.h"
#include "LSocket.h"
#include "Comm.h"
#include "Monitor.h"
/////////////////////////////////////////////////////////////////////////////
#define		DEBUG_VFO	FALSE
#define		STIMEOUT	2000
/////////////////////////////////////////////////////////////////////////////
// CRPServerDlg _CAO

class CRPServerDlg : public CDialog
{
private:
	DWORD			m_Freq;
private:
	int				m_PortTCP;
	CLSocket		*m_pSocket;
	CPtrList		m_Connection;
	CTcpFifo		m_TcpFifo;

	CCommPara		m_CommPara;
	CComm			*m_pComm;

	MONISTORAGE		m_MoniStorage;
	CMonitor		*m_pMonitor;
private:
	CColorStatic	m_csDlgNStatus;
	CColorStatic	m_csDlgPort;

private:
	void DispStatus(void);
	void DispCommStatus(void);
	void CloseSocket(CCSocket *pSocket);
	BOOL SendBuf(CCSocket *pSocket, LPVOID p, int n);
	BOOL SendClient(TCPD *tp);
	BOOL SendClient(int cmd, LPVOID p, int len);
	BOOL SendCommandRequest(int cmd);
	void SendBusy(int busy);
	void SendChar(BYTE c);
	void SendVFO(LONG fq);

	void UpdatePort(BOOL bSaveAndValidate);
	void OnPortChange(void);
	void OpenPort(void);
	void ClosePort(void);
	void SetPTT(int sw);
	void PutChar(BYTE c);
	inline BOOL IsCommOpen(void){return m_pComm != NULL;};

	void OpenMonitor(void);
	void CloseMonitor(void);

public:
	void OnAccept(int nErrorCode);
	void OnReceive(CCSocket *pSocket, int nErrorCode);
	inline MONISTORAGE *GetMonitorStorage(void){return &m_MoniStorage;};
// \z
public:
	CRPServerDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CRPServerDlg)
	enum { IDD = IDD_RPSERVER_DIALOG };
	CButton	m_DlgMonitor;
	CButton	m_DlgMinimized;
	int		m_DlgPort;
	int		m_DlgBaud;
	int		m_DlgLength;
	int		m_DlgStop;
	int		m_DlgParity;
	BOOL	m_DlgDTR;
	BOOL	m_DlgRTS;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CRPServerDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CRPServerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangePort();
	afx_msg void OnSelchangeBaud();
	afx_msg void OnSelchangeLength();
	afx_msg void OnSelchangeStop();
	afx_msg void OnSelchangeParity();
	afx_msg void OnDtr();
	afx_msg void OnRts();
	afx_msg void OnMinimize();
	afx_msg void OnMonitor();
	//}}AFX_MSG
	afx_msg LRESULT OnCommEvent(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSocketEvent(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

inline MONISTORAGE *GetMoniStorage(void){return ((CRPServerDlg *)(GetApp()->m_pMainWnd))->GetMonitorStorage();}

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_RPSERVERDLG_H__842C61C4_80A2_412E_B5D8_286FEC3FF2DE__INCLUDED_)
